
// PICvO}
// http://kyoutan.jpn.org/
//
// 2011N0403 gps̐ݒԈႦLED_ȂȂ̂C
// 2011N0402 gpso͂ɂ
// 2011N0325 ʂ蓮悤ɂȂ

#include "sfr_r8m12a.h"
#include "uart.h"
#include "pic.h"
#include "wait.h"

void main(void);

void main(void)
{
	unsigned short data;
	
	// gpso͂ɂ
	pd1=0b00001110;
	pd3=0b10110000;
	pd4=0b11000100;

	osc_init();
	uart_init();
	pic16enticsp();


	while(1)
	{
		unsigned char command;
		command=getch();
		switch(command)
		{
			// PIC16 ICSP R}h
			case 0x01:	// entpic16icsp
				pic16enticsp();
				putch(command);	// GR[Ԃ
				break;
				
			case 0x02:	// loadconfig
				loadconfig();
				putch(command);	// GR[Ԃ
				break;
				
			case 0x03:
				{
					unsigned short data;
					data=((unsigned short)getch()<<8);
					data+=(unsigned short)getch();
					loadPGM(data);
				}
				putch(command);	// GR[Ԃ
				break;
				
			case 0x04:
				{
					unsigned short data;
					data=readPGM();
					putch((data>>8)&0xFF);
					putch((data   )&0xFF);
				}
				break;
				
			case 0x05:
				incaddress();
				putch(command);	// GR[Ԃ
				break;
				
			case 0x06:
				beginerase();
				putch(command);	// GR[Ԃ
				break;
				
			case 0x07:
				beginprogrammingonly();
				putch(command);	// GR[Ԃ
				break;
				
			case 0x08:
				bulkerasePGM();
				putch(command);	// GR[Ԃ
				break;
				
			case 0x09:
				bulkeraseDAT();
				putch(command);	// GR[Ԃ
				break;
				
			case 0x0A:
				chiperase();
				putch(command);	// GR[Ԃ
				break;
				
			case 0x0B:
				loadDAT(getch());
				putch(command);	// GR[Ԃ
				break;
				
			case 0x0C:
				putch(readDAT());
				break;
				
				
			// PIC24 ICSP R}h
			case 0x30:
				pic24enticsp();
				putch(command);	// GR[Ԃ
				break;
				
			case 0x31:
				pic24exiticsp();
				putch(command);	// GR[Ԃ
				break;
				
			case 0x32:
				{
					unsigned long data;
					data =((unsigned long)getch()<<16);
					data+=((unsigned long)getch()<< 8);
					data+=((unsigned long)getch()    );
					sixserialexe(data);
				}
				putch(command);	// GR[Ԃ
				break;
				
			case 0x33:
				{
					unsigned short data;
					putshort(regoutserialexe());
				}
				break;
			
			// Zbgb` 64[h
			// W0,W7ɃAhXZbgĂgp
			case 0x34:
				{
					unsigned char a;
					for(a=0; a<32; a++)
					{
						sixserialexe(0x200000 + ((unsigned long)getshort() << 4)); // MOV #<LSW0>, W0
						sixserialexe(0x200001 + ((unsigned long)getshort() << 4)); // MOV #<MSB1:MSB0>, W1
						sixserialexe(0x200002 + ((unsigned long)getshort() << 4)); // MOV #<LSW1>, W2
						sixserialexe(0xEB0300); // CLR W6
						sixserialexe(0x000000); // NOP
						sixserialexe(0xBB0BB6); // TBLWTL [W6++], [W7]
						sixserialexe(0x000000); // NOP
						sixserialexe(0x000000); // NOP
						sixserialexe(0xBBDBB6); // TBLWTH.B [W6++], [W7++]
						sixserialexe(0x000000); // NOP
						sixserialexe(0x000000); // NOP
						sixserialexe(0xBBEBB6); // TBLWTH.B [W6++], [++W7]
						sixserialexe(0x000000); // NOP
						sixserialexe(0x000000); // NOP
						sixserialexe(0xBB1BB6); // TBLWTL [W6++], [W7++]
						sixserialexe(0x000000); // NOP
						sixserialexe(0x000000); // NOP
						//wait10us(10);
						//waitms(250);
						putch(command);	// GR[Ԃ
					}
				}
				break;
				
			//
			case 0x35:
				{
					sixserialexe(0xBA0B96);
					sixserialexe(0x000000);
					sixserialexe(0x000000);
					putshort(regoutserialexe());
					sixserialexe(0x000000);
					sixserialexe(0xBADBB6);
					sixserialexe(0x000000);
					sixserialexe(0x000000);
					sixserialexe(0xBAD3D6);
					sixserialexe(0x000000);
					sixserialexe(0x000000);
					putshort(regoutserialexe());
					sixserialexe(0x000000);
					sixserialexe(0xBA0BB6);
					sixserialexe(0x000000);
					sixserialexe(0x000000);
					putshort(regoutserialexe());
					sixserialexe(0x000000);
				}
				break;
				
			case 0xAA:	// ڑeXg
				putch(command);
				break;
		}
	}
}

